<?php

/*

Plugin Name: Youtube Video Feed Widget

Plugin URI: http://www.nsauditor.com/wordpress/youtube-video-feed-widget/

Description: The Widget shows Youtube video feeds

Author: Varuzhan Kankanyan

Author URI: http://www.nsauditor.com

Version: 1.0

License: GNU General Public License version 2.0 or above

License URI: http://www.gnu.org/licenses/gpl-2.0.html

*/



require_once('nsYoutubeFeedParser.class.php');



class YoutubeVideoFeedWidget extends WP_Widget

{

	function YoutubeVideoFeedWidget()

	{

		$widget_ops = array('classname' => 'YoutubeVideoFeedWidget', 'description' => __('The Widget shows Youtube video feeds', 'YoutubeVideoFeedWidget'));

		parent::WP_Widget( 

		false, 

		$name = __('Youtube Video Feed Widget', 'YoutubeVideoFeedWidget'),

		$widget_ops ); 

	}

	

	function widget($args, $instance)

	{

        extract( $args );

		$title = ( $instance['title'] ) ? $instance['title'] : 'Popular Videos';		

		$channel = ( $instance['channel'] ) ? $instance['channel'] : '';

		$maxfeeds = ( $instance['maxfeeds'] ) ? $instance['maxfeeds'] : 1;				

		$orderby = ( $instance['orderby'] ) ? $instance['orderby'] : 'viewCount';	

		$showrelated = ( $instance['showrelated'] ) ? $instance['showrelated'] : 0;		

		$showtitle = ( $instance['showtitle'] ) ? $instance['showtitle'] : 0;			

		$showdesc = ( $instance['showdesc'] ) ? $instance['showdesc'] : 0;				

		$maxsentences = ( $instance['maxsentences'] ) ? $instance['maxsentences'] : 1;

		$maxtextsz = ( $instance['maxtextsz'] ) ? $instance['maxtextsz'] : 400;

        echo $before_widget;

        $widget_title = '<h3>'.$before_title . $title . $after_title.'</h3>';



        // Display Youtube Videos

        displayYoutubeVideos($widget_title,$channel,$maxfeeds,$orderby,$showrelated,$showtitle,$showdesc,$maxsentences,$maxtextsz);

        echo $after_widget;



		

	}

	function update($new_instance,$old_instance)

	{

      $instance = $old_instance;



      $instance['title'] = strip_tags($new_instance['title']);

      $instance['channel'] = strip_tags($new_instance['channel']);

      $instance['maxfeeds'] = strip_tags($new_instance['maxfeeds']);

      $instance['orderby'] = strip_tags($new_instance['orderby']);	

      $instance['showrelated'] = strip_tags($new_instance['showrelated']);		  

      $instance['showtitle'] = strip_tags($new_instance['showtitle']);	  

      $instance['showdesc'] = strip_tags($new_instance['showdesc']);	

      $instance['maxsentences'] = strip_tags($new_instance['maxsentences']);	

      $instance['maxtextsz'] = strip_tags($new_instance['maxtextsz']);		  

		

		return $new_instance;

	}

	

	function form($instance)

	{

		$orderby = $instance['orderby'];

		?>		

		<p>

			<label for="<?php echo $this->get_field_id('title'); ?>">

				<?php _e( 'Widget Title' ); ?>:

				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($instance['title']); ?>" />

			</label>

		</p>	

		

		<p>

			<label for="<?php echo $this->get_field_id('channel'); ?>">

				<?php _e( 'Youtube Channel' ); ?>:

				<input class="widefat" id="<?php echo $this->get_field_id('channel'); ?>" name="<?php echo $this->get_field_name('channel'); ?>" type="text" value="<?php echo esc_attr($instance['channel']); ?>" />

			</label>

		</p>			

		

		<p>

			<label for="<?php echo $this->get_field_id('maxfeeds'); ?>">

				<?php _e('Video Feeds Count to display'); ?>:

				<input style="text-align: center;" id="<?php echo $this->get_field_id('maxfeeds'); ?>" name="<?php echo $this->get_field_name('maxfeeds'); ?>" type="text" value="<?php echo absint($instance['maxfeeds']); ?>" size='3' />

			</label>

		</p>	

		

		<p>

			<label for="<?php echo $this->get_field_id('orderby'); ?>">

				<?php _e('Order By'); ?>

				<select name="<?php echo $this->get_field_name('orderby'); ?>" id="<?php echo $this->get_field_id('orderby'); ?>" class="widefat">

				<?php

					$options = array('viewCount','rating','published','relevance');

					foreach ($options as $option) {

					echo '<option value="' . $option . '" id="' . $option . '"', $orderby == $option ? ' selected="selected"' : '', '>', $option, '</option>';

				}

				?>

				</select>

			</label>

		</p>

		

		<p>

			<label for="<?php echo $this->get_field_id('showrelated'); ?>">

				<?php _e('Show Page Related Video Feeds'); ?>:

				<input style="text-align: center;" id="<?php echo $this->get_field_id('showrelated'); ?>" name="<?php echo $this->get_field_name('showrelated'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['showrelated']) ); ?> /">

			</label>

		</p>			

		

		<p>

			<label for="<?php echo $this->get_field_id('showtitle'); ?>">

				<?php _e('Show Video Feed Title'); ?>:

				<input style="text-align: center;" id="<?php echo $this->get_field_id('showtitle'); ?>" name="<?php echo $this->get_field_name('showtitle'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['showtitle']) ); ?> /">

			</label>

		</p>		

		

		

		<p>

			<label for="<?php echo $this->get_field_id('showdesc'); ?>">

				<?php _e('Show Video Feed Description'); ?>:

				<input style="text-align: center;" id="<?php echo $this->get_field_id('showdesc'); ?>" name="<?php echo $this->get_field_name('showdesc'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['showdesc']) ); ?> /">

			</label>

		</p>		



		<p>

			<label for="<?php echo $this->get_field_id('maxsentences'); ?>">

				<?php _e('Number of Sentences'); ?>:

				<input style="text-align: center;" id="<?php echo $this->get_field_id('maxsentences'); ?>" name="<?php echo $this->get_field_name('maxsentences'); ?>" type="text" value="<?php echo absint($instance['maxsentences']); ?>" size='3' />

			</label>

		</p>	



		<p>

			<label for="<?php echo $this->get_field_id('maxtextsz'); ?>">

				<?php _e('Maximum Description Size'); ?>:

				<input style="text-align: center;" id="<?php echo $this->get_field_id('maxtextsz'); ?>" name="<?php echo $this->get_field_name('maxtextsz'); ?>" type="text" value="<?php echo absint($instance['maxtextsz']); ?>" size='3' />

			</label>

		</p>			

		

		<?php	

	}

}



function displayYoutubeVideos($widget_title,$channel,$maxfeeds,$orderby,$showrelated,$showtitle,$showdesc,$maxsentences,$maxtextsz)

{

	$content = '';	

	$nsYoutubeFeedParser = new nsYoutubeFeedParser($channel);

	$count = $maxfeeds;

	if($showrelated)

	{

		$query='';

		$pagetitle = get_the_title();

	

		$query=strtolower ($pagetitle);			

		$query=str_replace(' ','+',$query);	

	

		$count = $nsYoutubeFeedParser->parseYoutubeFeed($orderby,$maxfeeds,$query);

		if($count==0)

		{

			$id = get_the_id();

			$terms = get_the_terms($id,'category');	

			$cats = array();

			if(is_array($terms)){

				foreach($terms as $term){

					$cats[]=$term->name;

				}

			}

			if(count($cats))

			{

				$query = implode("+", $cats);

				$query=str_replace(' ','+',$query);			

			}

			else

			{

				$terms = get_the_terms($id,'post_tag');	

				$tags = array();

				if(is_array($terms)){

					foreach($terms as $term){

						$tags[]=$term->name;

					}	

				}

				$query = implode("+", $tags);

				$query=str_replace(' ','+',$query);			

			}	

			

			$count = $nsYoutubeFeedParser->parseYoutubeFeed($orderby,$maxfeeds,$query);

			if($count==0){$count = $nsYoutubeFeedParser->parseYoutubeFeed($orderby,$maxfeeds);}

		}

	}

	else

	{

		$count = $nsYoutubeFeedParser->parseYoutubeFeed($orderby,$maxfeeds);

	}

	$nsYoutubeFeedNode = new nsYoutubeFeedNode;

	

	if($count) {$content .= $widget_title;}

	if($count>$maxfeeds) $count=$maxfeeds;



	for($i = 0; $i < $count; $i++)

	{

		if($nsYoutubeFeedParser->getYFeedEntry($nsYoutubeFeedNode,$i,$maxsentences,$maxtextsz))

		{		

			$content .= "<div style='margin: 0 0 15px 0;background: #f4f4f4;box-shadow: 0 6px 8px 0 rgba(0, 0, 0, 0.4);padding: 5px;border-radius: 4px;'>";

			if($showtitle){$content .= "<div style='padding: 8px 0 9px;text-align:center;font-weight:bold;'><a href='$nsYoutubeFeedNode->link' target='_blank'>$nsYoutubeFeedNode->title</a></div>";}

			$content .= "<div><iframe width='300' height='220' src='$nsYoutubeFeedNode->id' frameborder='0' allowfullscreen></iframe></div>";	

			if($showdesc){$content .= "<div style='text-align:center';><p>$nsYoutubeFeedNode->description</p></div>";}

			$content .= "</div>";

		}

	}

	

	unset($nsYoutubeFeedParser);

	unset($nsYoutubeFeedNode);

		

	echo $content;

}



add_action('widgets_init','YoutubeVideoFeedWidgetInit');



function YoutubeVideoFeedWidgetInit()

{

	register_widget('YoutubeVideoFeedWidget');

}



?>